=== scripts/autotune-search/requirements.txt ===
scipy
pathos
rich
