=== debian/changelog ===
rocprim (6.4.3-2) unstable; urgency=medium

  * Add d/p/fix-asm-thread-load-store.patch to fix FTBFS when
    building rocprim test_thread_algos for gfx1100 (Closes: #1119960)

 -- Cordell Bloor <cgmb@debian.org>  Mon, 03 Nov 2025 01:38:06 -0700

rocprim (6.4.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Remove Maxime Chambonnet from uploaders due to inactivity
  * Update my email address and copyright info
  * Update pkg-rocm-tools minimum version to 0.9.3 in B-D
  * Replace CMAKE_SKIP_RPATH with CMAKE_SKIP_INSTALL_RPATH to allow
    rpath use for build-time tests
  * Remove use of ROCPRIM_USE_ARCH_CONVERSION from librocprim-tests
    as this depends on functionality not available in libamdhip64-6
  * Add d/p/add-option-to-disable-deprecation-warnings.patch to
    disable rocprim deprecation warnings when building rocprim tests
  * Add d/p/skip-building-test_device_scan.patch to skip building
    test_device_scan due to a compilation failure

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Fri, 31 Oct 2025 14:36:39 -0600

rocprim (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3
  * Update d/gbp.conf to follow DEP-14
  * Update for new rocm-target-arch

 -- Christian Kastner <ckk@debian.org>  Sat, 09 Aug 2025 09:31:16 +0200

rocprim (6.4.1-1~exp3) experimental; urgency=medium

  [ Cordell Bloor ]
  * Add d/p/fix-legacy-stream-version-check.patch to fix
    compatibility with HIP 6.1

  [ Christian Kastner ]
  * Use rocm-target-arch to select and document build GPU arch
  * Improve the run-tests runner

 -- Christian Kastner <ckk@debian.org>  Sat, 12 Jul 2025 22:47:22 +0200
