=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/librocprim-tests/run-tests
Features: test-name=librocprim-tests
Depends: pkg-rocm-tools, librocprim-tests
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
