=== debian/watch ===
Version: 5

Source: https://github.com/rocm/rocprim/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocprim-$1.tar.gz%
